Subject: Re: bug#32599: 25.2; Feature request: input PUA characters by name

From: [email-masked] (Janusz S. Bień)
Date: Sun, 26 May 2019 17:18:21 +0200

On Sun, May 26 2019 at 17:45 +03, Eli Zaretskii wrote:
>> From: [email-masked] (Janusz S. Bień)
>> Date: Sun, 26 May 2019 10:10:02 +0200
>> 
>> > First, the MUFI data in a more convenient form are available here:
>> >
>> > On Mon, Aug 27 2018 at  9:00 +0200, [email-masked] writes:
>> >
>> > [...]
>> >
>> >> https://bitbucket.org/jsbien/unihistext/src/master/example/
>> 
>> If you prefer a file pattern after UnicodeData.txt, you can find it
>> here:
>> 
>> http://www.kreativekorp.com/charset/PUADATA/PUBLIC/MUFI/
>> 
>> >
>> > Secondly, other users may be interested in other sets of PUA characters,
>> > cf.
>> >
>> > http://andron-typeforum.xobor.de/t10f13-Towards-a-linguistic-corporate-use-area-LINCUA.html
>> > https://en.wikipedia.org/wiki/ConScript_Unicode_Registry
>> 
>> or Under-ConScript Unicode Registry:
>> 
>> http://www.kreativekorp.com/ucsur/
>
> The UnicodeData.txt file is compiled into Emacs,

I know and I'm curious whether it is really needed. Why it cannot be
loaded at the startup? The advantage would be the user can use always
the up-to-date version of UnicodeData.txt (have you noticed that since
7th May we have now Unicode 12.1 because SQUARE ERA NAME REIWA was
added?).

> but the files you mention cannot be compiled into it, because they
> vary, and because different users might want different lists of
> characters to be supported.  So we need to design how this will work.

My naive idea is to "cheat" Emacs by providing it with the extended data
without changing the original logic. Efficiency is less important than
convenience, perhaps you can "advice"  the 'describe-char' function to
look for the data elsewhere.

> In addition, I think PUA codepoints aren't really treated as
> characters in Emacs, so there's a need for some infrastructure
> changes.

I do not propose to support the supplemental PUA planes. For the BMP
this probably boils down to the availability of the property
information. As we have now a pseudo-UnicodeData.txt for the PUA
characters (at least thise I'm interested in) this doesn't seem to me a
big problem).

> Patches welcome.

Unfortunately I'm unable to provide them myself.

Best regards

Janusz

-- 
             ,   
Janusz S. Bien
emeryt (emeritus)
https://sites.google.com/view/jsbien